unit Http;

interface

uses
    Windows, SysUtils, Classes, WinSock;

//-----------------------------------------------------------------------------
//  UTILITY
function URLEncode(const S: string): string;
function URLDecode(const S: string): string;
function SplitUrl(const Url: string; var Host, Page: string): Boolean;

//-----------------------------------------------------------------------------
//  DOWNLOAD
type TCallbackDownload = function (const Buf; const BufLen: integer): Boolean of object;
function DownloadViaHTTP(const host, HttpCommand: string; Download: TCallbackDownload): Boolean;

implementation

//-----------------------------------------------------------------------------
//  2005.08.26  URLGR[h
//  http://www.delphidabbler.com/codesnip.php?action=named&routines=URLEncode&showsrc=1
//  http://cvs.sourceforge.jp/cgi-bin/viewcvs.cgi/jane/jane/HTTPSub.pas?rev=1.2&content-type=text/vnd.viewcvs-markup
function URLEncode(const S: string): string;
var
    i, l: integer;
    c: char;
begin
    Result := '';
    l := Length(S);
    for i := 1 to l do
    begin
        c := S[i];
        if (c in ['A'..'Z', 'a'..'z', '0'..'9', '-', '_', '.']) then
        begin
            Result := Result + c;
        end
        else
        begin
            Result := Result + '%' + IntToHex(Ord(c), 2);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  2005.08.26  URLfR[h
//  http://www.delphidabbler.com/codesnip.php?action=named&routines=URLDecode&showsrc=1
function URLDecode(const S: string): string;
var
    i, l: integer;
    c: char;
    Hex: string;
    Code: Integer;
begin
    Result := '';
    i := 1;
    l := Length(S);
    while (i <= l) do
    begin
        c := S[i];

        //  % ̌ɂ2͂
        if (c = '%') then
        begin
            //  2ȏcĂȂƂ
            if (i <= l - 2) then
            begin
                Hex := Copy(S, i + 1, 2);
                Code := StrToIntDef('$' + Hex, -1);
                Inc(i, 2);
            end
            //  ߂
            else
            begin
                Code := -1;
            end;

            //  fR[hs
            if (Code < 0) then
            begin
                Result := S;
                Exit;
            end
            //  fR[h
            else
            begin
                Result := Result + Chr(Code);
            end;
        end
        //  +
        else if (c = '+') then
        begin
            Result := Result + ' ';
        end
        //  ̑
        else
        begin
            Result := Result + c;
        end;

        Inc(i);
    end;
end;

//-----------------------------------------------------------------------------
//  2005.09.04  URLzXgƃy[Wɕ
function SplitUrl(const Url: string; var Host, Page: string): Boolean;
var
    Url2: string;
    p: integer;
begin
    Result := false;
    Url2 := Url;

    //  uhttp://vŎn܂Ă邩H
    p := Pos('http://',  Url2); 
    if (p = 1) then
    begin
        Delete(Url2, 1, Length('http://'));

        //  zXgo(ŏɌu/v܂)
        p := Pos('/',  Url2);

        //  ݂ȂΑSzXg
        if (p = 0) then
        begin
            p := Length(Url2);
            Url2 := Url2 + '/';
        end
        //  u/v̒O܂łzXg
        else
        begin
            Dec(p);
        end;

        //  zXgo
        Host := Copy(Url2, 1, p);

        //  zXg
        Delete(Url2, 1, p);

        //  c肪y[W
        Page := Url2;

        Result := true;
    end;
end;

//-----------------------------------------------------------------------------
//  IPAhX`̕񂩂ǂ𒲂ׂ
function IsIpText(const s: string): Boolean;

    function IsByteText(const str: string): Boolean;
    var
        j: integer;
    begin
        //  `FbN
        if not TryStrToInt(str, j) then Result := false
        //  `FbN-2
        else if (j < 0) or (255 < j) then Result := false
        //  ʂ
        else Result := true;
    end;

var
    l1, l2: integer;
    t, t1: string;
begin
    Result := false;

    //  sIhɁA񒷂3ւȂƂ
    l1 := Length(s);
    l2 := Length(StringReplace(s, '.', '', [rfReplaceAll]));
    if (l1 <> l2 + 3) then Exit;

    //  ŏ̐
    t := s;
    t1 := Copy(t, 1, Pos('.', t) - 1);

    //  `FbN
    if not IsByteText(t1) then Exit;

    //  2Ԗڂ̐
    Delete(t, 1, Length(t1) + 1);
    t1 := Copy(t, 1, Pos('.', t) - 1);

    //  `FbN
    if not IsByteText(t1) then Exit;

    //  3Ԗڂ̐
    Delete(t, 1, Length(t1) + 1);
    t1 := Copy(t, 1, Pos('.', t) - 1);

    //  `FbN
    if not IsByteText(t1) then Exit;

    //  4Ԗڂ̐
    Delete(t, 1, Length(t1) + 1);
    t1 := t;

    //  `FbN
    if not IsByteText(t1) then Exit;

    //  ʂ
    Result := true;
end;

//-----------------------------------------------------------------------------
// IPAhXzXgIPAhXłԂ
// http://www.asahi-net.or.jp/~nk2w-ishr/winsock3.htm
function GetInetAddr(s: string): integer;
var
    ip : u_long;
    phe: PHostEnt;
begin
    phe := nil;

    //  10i\L̏ꍇ
    if IsIpText(s) then
    begin
        ip := inet_addr(PChar(s));
        if (ip <> INADDR_NONE) then phe := gethostbyaddr(@ip, 4, AF_INET);
    end
    //  zXg\L̏ꍇ
    else
    begin
        phe := gethostbyname(PChar(s))
    end;

    //  ߂
    if not Assigned(phe) then
    begin
        raise Exception.Create(Format('[%s] IS INVALID ADDRSS.', [s]));
    end;

    //  ł֕ϊ
    Result := inet_addr(inet_ntoa(PInAddr(phe^.h_addr_list^)^));
end;

//-----------------------------------------------------------------------------
//  2005.09.08  T[o[ւGETR}hoƕԎ擾
function DownloadViaHTTP(const host, HttpCommand: string; Download: TCallbackDownload): Boolean;
var
    Command: string;
    sock: TSocket;
    sockaddr: TSockAddr;
    sendlen: integer;
    recvlen: integer;
    recvdata: array[0..1024] of Char;
    StrBuf: TStringList;
begin
    Result := false;
    StrBuf := nil;
    sock := INVALID_SOCKET;
    try
        try
            StrBuf := TStringList.Create;

            //-----------------------------------------------------------
            //  \Pbg쐬
            sock := socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);

            //-----------------------------------------------------------
            //  ꂽH
            if sock = INVALID_SOCKET then
            begin
                raise Exception.Create(SysErrorMessage(GetLastError()));
            end;

            //-----------------------------------------------------------
            //  ڑ̃AhXE|[gw
            FillChar(sockaddr, SizeOf(TSockAddr), #0);
            sockaddr.sin_family      := AF_INET;
            sockaddr.sin_port        := htons(80);
            sockaddr.sin_addr.S_addr := GetInetAddr(host);

            //-----------------------------------------------------------
            //  ڑ
            if connect(sock, sockaddr, sizeof(sockaddr)) = SOCKET_ERROR then
            begin
                raise Exception.Create(SysErrorMessage(GetLastError()));
            end;

            //-----------------------------------------------------------
            //  M
            Command := HttpCommand;
            sendlen := send(sock, Command[1], Length(Command), 0);
            if sendlen = SOCKET_ERROR then
            begin
                raise Exception.Create(SysErrorMessage(GetLastError()));
            end;

            //-----------------------------------------------------------
            //  M
            while True do
            begin
                //  
                FillChar(recvdata, SizeOf(recvdata), #0);

                //  󂯂Ă݂
                recvlen := recv(sock, recvdata, Length(recvdata), 0);

                //  G[ȂI
                if recvlen = SOCKET_ERROR then break;

                //  ȂI
                if recvlen = 0 then break;

                //  ݂ƃLZ
                if (not Download(recvdata, recvlen)) then break;
            end;

            //  
            Result := true;

        finally
            //-----------------------------------------------------------
            // \Pbg̔j
            if (sock <> INVALID_SOCKET) then closesocket(sock);

            FreeAndNil(StrBuf);
        end;
    except
        on E:Exception do
        begin
            raise Exception.Create(E.Message);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  WinSock
var
    ad: TWSAData;

initialization
    WSAStartup($0101, ad);

//-----------------------------------------------------------------------------
//  n
finalization
    WSACleanup();

end.
